%global commit 552dd691215cdafdbe6706e6f76be9d392fb3ffe
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:		castxml
Version:	0.1
Release:	0.6.20150924git%{shortcommit}%{?dist}
Summary:	C-family abstract syntax tree XML output tool

#		The main program is Apache 2.0
#		src/kwsys/* is BSD
License:	ASL 2.0 and BSD
URL:		https://github.com/CastXML/CastXML
Source0:	https://github.com/CastXML/CastXML/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
#		Link against shared llvm library.
#		Currently the libclang.so in Fedora is incomplete, so we
#		can not do the same for the clang library (rhbz 1211943).
Patch0:		%{name}-shared.patch

BuildRequires:	cmake
BuildRequires:	llvm-devel >= 3.6.0
#		Currently the libclang.so in Fedora is incomplete, so we
#		have to use the static clang libraries (rhbz 1211943).
#		For some reason these are in the llvm-static package
#		instead of in their own clang-static package.
BuildRequires:	llvm-static >= 3.6.0
BuildRequires:	clang-devel >= 3.6.0
BuildRequires:	libedit-devel
BuildRequires:	zlib-devel
BuildRequires:	python-sphinx
#		Bundled components of the kitware system library
#		https://fedorahosted.org/fpc/ticket/555
Provides:	bundled(kwsys-encoding)
Provides:	bundled(kwsys-process)
Provides:	bundled(kwsys-system)
Obsoletes:	gccxml < 0.9.0-0.28

%description
Parse C-family source files and optionally write a subset of the
Abstract Syntax Tree (AST) to a representation in XML.

Source files are parsed as complete translation units using the clang
compiler. XML output is enabled by the --castxml-gccxml option and
produces a format close to that of gccxml. Future versions of castxml
may support alternative output formats.

%prep
%setup -q -n CastXML-%{commit}
%patch0 -p1

# LLVM_LIBRARY_DIRS does not work, and can not be overridden with -D flag
sed 's!${LLVM_LIBRARY_DIRS}!${LLVM_LIBRARY_DIR}!' -i CMakeLists.txt

%build
%cmake -DCastXML_INSTALL_DOC_DIR:STRING=share/doc/%{name} \
       -DCastXML_INSTALL_MAN_DIR:STRING=share/man \
       -DLLVM_LIBRARY_DIR=%{_libdir}/llvm \
       -DCLANG_RESOURCE_DIR:PATH=$(clang -print-file-name=include)/.. \
       -DKWSYS_BUILD_SHARED:BOOL=OFF \
       -DBUILD_TESTING:BOOL=ON \
       -DSPHINX_MAN:BOOL=ON
make %{?_smp_mflags}

%install
make %{?_smp_mflags} install DESTDIR=%{buildroot}
rm %{buildroot}%{_pkgdocdir}/LICENSE
rm %{buildroot}%{_pkgdocdir}/NOTICE

%check
ctest %{?_smp_mflags}

%files
%{_bindir}/castxml
%doc %{_mandir}/man1/castxml.1*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/clang
%{_datadir}/%{name}/detect_vs.c
%{_datadir}/%{name}/detect_vs.cpp
%{_datadir}/%{name}/empty.c
%{_datadir}/%{name}/empty.cpp
%license LICENSE NOTICE src/kwsys/Copyright.txt

%changelog
* Fri Sep 25 2015 Mattias Ellert <mattias.ellert@fysast.uu.se> - 0.1-0.6.20150924git552dd69
- Adjust gccxml obsolete version

* Thu Sep 24 2015 Mattias Ellert <mattias.ellert@fysast.uu.se> - 0.1-0.5.20150924git552dd69
- New git snapshot
- Allow warnings about guessing the float ABI during tests (fixes tests on arm)

* Thu Sep 17 2015 Mattias Ellert <mattias.ellert@fysast.uu.se> - 0.1-0.4.20150902git7acd634
- New git snapshot

* Fri Aug 21 2015 Mattias Ellert <mattias.ellert@fysast.uu.se> - 0.1-0.3.20150820git2e55b35
- New git snapshot
- Upstream has deleted the parts of the bundled kwsys sources that are not
  used by castxml from the source repository
- Add bundled provides for the remaining kwsys components according to
  revised FPC decision 2015-08-20
  https://fedorahosted.org/fpc/ticket/555

* Fri Aug 07 2015 Mattias Ellert <mattias.ellert@fysast.uu.se> - 0.1-0.2.20150807git8a08a44
- New git snapshot
- Unbundle kwsys library according to FPC decision 2015-08-06
  https://fedorahosted.org/fpc/ticket/555

* Tue Apr 14 2015 Mattias Ellert <mattias.ellert@fysast.uu.se> - 0.1-0.1.20150414git43fa139
- First packaging for Fedora
